import json
import numpy as np
import pandas as pd
import os
import shutil
import time
import h5py
import matplotlib.pyplot as plt
import plot as plot
import interpolate as interpol
import time_handler as time_handle
import use_patterns as use_pat
import on_patterns as on_pat
import off_patterns as off_pat
import standby_patterns as standby_pat


def TV(t):
    global use
    global on
    global off
    global standby

    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        use, t_use = use_pat.TV_use()
        on, n_rows_on = on_pat.TV_on()
        standby, t_standby = standby_pat.TV_standby()
        off, n_rows_off = off_pat.TV_off()
        a = np.random.randint(550000, 650000)
        a = a + i*day
        data = np.zeros((t), dtype=None)


        for i in range(n_rows_on-1):
            data[a+i] = on[i]

        for i in range(t_use-1):
            data[a+(n_rows_on-1)+i] = use[i]

        for i in range(t_standby-1):
            data[a+(n_rows_on-1)+(t_use-1)+i] = standby[i]

        for i in range(n_rows_off-1):
            data[a+(n_rows_on-1)+(t_use-1) +
                 (t_standby-1)+i] = off[i]
        data_final += data

    data_final = np.transpose(data_final)

    return data_final


def printer(t):
    global use
    global on
    global off

    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        r = np.random.randint(0, 1)
        use, t_use = use_pat.printer_use(r)
        on, n_rows_on = on_pat.printer_on()
        off, n_rows_off = off_pat.printer_off()
        a = np.random.randint(350000, 700000)
        a = a + i*day
        data = np.zeros((t), dtype=None)

        for i in range(n_rows_on-1):
            data[a+i] = on[i]

        for i in range(t_use-1):
            data[a+(n_rows_on-1)+i] = use[i]

        for i in range(n_rows_off-1):
            data[a+(n_rows_on-1)+(t_use-1)+i] = off[i]
        data_final += data

    data_final = np.transpose(data_final)

    return data_final


def coffeemachine(t):

    global use
    global on
    global off
    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        on, n_rows_on = on_pat.coffeemachine_on()
        off, n_rows_off = off_pat.coffeemachine_off()
        standby, t_standby = standby_pat.coffeemachine_standby()


        s = np.random.randint(0, 2)
        if s == 0:
            a = np.random.randint(300000, 350000)
            a = a + i*day
            data_day = np.zeros((t), dtype=None)

            for i in range(n_rows_on-1):
                data_day[a+i] = on[i]

            count = np.random.randint(1, 4)
            for i in range(count):
                r = np.random.randint(0, 3)
                use, t_use = use_pat.coffeemachine_use(r)
                for j in range(t_use-1):
                    data_day[a+(n_rows_on-1)+i*j] = use[j]

            for i in range(t_standby-1):
                data_day[a+(n_rows_on-1) +
                         (count*t_use-1)+i] = standby[i]

            for i in range(n_rows_off-1):
                data_day[a+(n_rows_on-1)+(count *
                                          t_use-1)+(t_standby-1)+i] = off[i]
            data_final += data_day

        else:
            b = np.random.randint(500000, 550000)
            b = b + i*day
            data_day = np.zeros((t), dtype=None)

            for i in range(n_rows_on-1):
                data_day[b+i] = on[i]

            count = np.random.randint(1, 4)
            for i in range(count):
                r = np.random.randint(0, 3)
                use, t_use = use_pat.coffeemachine_use(r)
                for j in range(t_use-1):
                    data_day[b+(n_rows_on-1)+i*j] = use[j]

            for i in range(t_standby-1):
                data_day[b+(n_rows_on-1) +
                         (count*t_use-1)+i] = standby[i]

            for i in range(n_rows_off-1):
                data_day[b+(n_rows_on-1)+(count *
                                          t_use-1)+(t_standby-1)+i] = off[i]
            data_final += data_day

    data_final = np.transpose(data_final)

    return data_final


def laptop(t):

    global use
    global on
    global off

    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        use, t_use = use_pat.laptop_use()
        on, n_rows_on = on_pat.laptop_on()
        off, n_rows_off = off_pat.laptop_off()
        a = np.random.randint(400000, 700000)
        a = a + i*day
        data = np.zeros((t), dtype=None)

        for i in range(n_rows_on-1):
            data[a+i] = on[i]

        for i in range(t_use-1):
            data[(a+n_rows_on-1)+i] = use[i]

        for i in range(n_rows_off-1):
            data[(a+n_rows_on-1)+(t_use-1)+i] = off[i]
        data_final += data

    data_final = np.transpose(data_final)

    return data_final


def lamp(t):

    global use
    global on
    global off

    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        use, t_use = use_pat.lamp_use()
        on, n_rows_on = on_pat.lamp_on()
        off, n_rows_off = off_pat.lamp_off()
        a = np.random.randint(600000, 700000)
        a = a + i*day
        data = np.zeros((t), dtype=None)

        for i in range(n_rows_on-1):
            data[a+i] = on[i]

        for i in range(t_use-1):
            data[(a+n_rows_on-1)+i] = use[i]

        for i in range(n_rows_off-1):
            data[(a+n_rows_on-1)+(t_use-1)+i] = off[i]
        data_final += data

    data_final = np.transpose(data_final)

    return data_final


def gaming_PC(t):

    global use
    global on
    global off

    day = 864000
    n_days = t//day
    data_final = np.zeros((t), dtype=None)
    for i in range(n_days):

        r = np.random.randint(0, 2)
        use, t_use = use_pat.gaming_PC_use(r)
        on, n_rows_on = on_pat.gaming_PC_on()
        off, n_rows_off = off_pat.gaming_PC_off()
        a = np.random.randint(500000, 700000)
        a = a + i*day
        data = np.zeros((t), dtype=None)

    
        for i in range(n_rows_on-1):
            data[a+i] = on[i]

        for i in range(t_use-1):
            data[a+(n_rows_on-1)+i] = use[i]

        for i in range(n_rows_off-1):
            data[a+(n_rows_on-1)+(t_use-1)+i] = off[i]
        data_final += data

    data_final = np.transpose(data_final)

    return data_final
