import json
import numpy as np
import pandas as pd
import os, shutil, time, h5py
import matplotlib.pyplot as plt
import plot as plot
import interpolate as interpol
import time_handler as time_handle
import use_patterns as use_pat

def csv_read(filename, root_dir):

    filepath = os.path.join(root_dir, filename)

    if not os.path.isfile(filepath):
        filepath = filepath[:-3]+filepath[-3:].upper()
    
    n_cols = 1
    n_rows = sum(1 for line in open(filepath))-10
    data = np.zeros((n_rows, n_cols), dtype=None)

    X = pd.read_csv(filepath.format(1), sep=',', header=None, index_col=None, usecols=[2], skiprows=8, nrows=n_rows, doublequote=True, dtype=None)
    X.fillna(value=None, method='ffill')
    X.clip(lower=0)
    data[:,:] = X.values

    return data, n_rows
